import {GET_systemSettingsAction} from '../../reducers/systemSettingsSite/crud/getSystemSettingsReducer'
import {ActionType} from '../../reducers/systemSettingsSite/systemSettingsSiteActionTypes'
import {delay} from '../../../../debug'
import {
  changeSystemSettingsFromBackend, getAllDefaultGroups, getAllDefaultRoles, getInitialSystemSettingsFromBackend,
  getSystemSettingsFromBackend
} from '../../../communicationLayer/systemSettingsLayer'
import {SystemSettingsForBackend} from '../../../types/systemSettings'
import {UPDATE_systemSettingsAction} from '../../reducers/systemSettingsSite/crud/updateSystemSettingsReducer'
import {GET_initialSystemSettingsAction} from '../../reducers/systemSettingsSite/crud/getInitialSystemSettingsReducer'
import {GET_allDefaultGroupsAction} from '../../reducers/systemSettingsSite/crud/getAllDefaultGroupsReducer'
import {GET_allDefaultRolesAction} from '../../reducers/systemSettingsSite/crud/getAllDefaultRolesReducer'

export function getSystemSettingsAsync(): GET_systemSettingsAction {
  return {
    type: ActionType.GET_systemSettings,
    payload: delay(getSystemSettingsFromBackend())
  }
}

export function getInitialSystemSettingsAsync(): GET_initialSystemSettingsAction {
  return {
    type: ActionType.GET_initialSystemSettings,
    payload: delay(getInitialSystemSettingsFromBackend())
  }
}


export function updateSystemSettingsAsync(systemSettings: SystemSettingsForBackend): UPDATE_systemSettingsAction {
  return {
    type: ActionType.UPDATE_systemSettings,
    payload: delay(changeSystemSettingsFromBackend(systemSettings))
  }
}


export function getAllDefaultGroupsAsync(): GET_allDefaultGroupsAction {
  return {
    type: ActionType.GET_allDefaultGroups,
    payload: delay(getAllDefaultGroups())
  }
}

export function getAllDefaultRolesAsync(): GET_allDefaultRolesAction {
  return {
    type: ActionType.GET_allDefaultRoles,
    payload: delay(getAllDefaultRoles())
  }
}

